<template>
  <div class="search-results">
    <div class="search-results__caption loader" v-if="loading"></div>
    <div class="search-results__caption" v-if="noResults && !loading">
      No movie found =(
    </div>
    <div class="search-results__grid" v-if="showResults">
      <SearchResultItem
        class="search-results__item"
        v-for="item in items"
        :key="item.id"
        :item="item"
      />
    </div>
  </div>
</template>

<script>
import SearchResultItem from "@/components/SearchResultItem";
import { mapGetters } from "vuex";

export default {
  name: "search-results",
  components: {
    SearchResultItem
  },
  props: {
    items: {
      type: Array,
      default: () => []
    }
  },
  computed: {
    ...mapGetters(["loading"]),
    noResults() {
      return this.items.length === 0;
    },
    showResults() {
      return !this.loading && !this.noResults;
    }
  }
};
</script>

<style scoped>
.search-results {
  background-color: #232323;
  color: white;
  font-family: sans-serif;
  min-height: 200px;
}

.search-results__caption {
  display: flex;
  justify-content: center;
  margin: 0px;
}

.search-results__item {
  margin: 20px;
}

.search-results__grid {
  grid-template-columns: repeat(auto-fill, 374px);
  display: grid;
  flex-direction: column;
  justify-content: space-between;
}

.loader {
  margin: 0px;
  border: 16px solid #555555;
  border-top: 16px solid #f65261;
  border-radius: 50%;
  width: 120px;
  height: 120px;
  animation: spin 2s linear infinite;
}

@keyframes spin {
  0% {
    transform: rotate(0deg);
  }
  100% {
    transform: rotate(360deg);
  }
}
</style>
